Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Standard Ed. 5.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.util.concurrent.atomic
Class AtomicReferenceFieldUpdater<T,V>

    java.lang.Object
      java.util.concurrent.atomic.AtomicReferenceFieldUpdater<T,V>

Type Parameters:
  `T` - The type of the object holding the updatable field
  `V` - The type of the field

    public abstract class AtomicReferenceFieldUpdater<T,V>

extends Object

A reflection-based utility that enables atomic updates to designated `volatile` reference fields of designated classes. This class is designed for use in atomic data structures in which several reference fields of the same node are independently subject to atomic updates. For example, a tree node might be declared as

     class Node {
       private volatile Node left, right;

       private static final AtomicReferenceFieldUpdater<Node, Node> leftUpdater =
         AtomicReferenceFieldUpdater.newUpdater(Node.class, Node.class, "left");
       private static AtomicReferenceFieldUpdater<Node, Node> rightUpdater =
         AtomicReferenceFieldUpdater.newUpdater(Node.class, Node.class, "right");

       Node getLeft() { return left;  }
       boolean compareAndSetLeft(Node expect, Node update) {
         return leftUpdater.compareAndSet(this, expect, update);
       }
       // ... and so on
     }

Note that the guarantees of the `compareAndSet` method in this class are weaker than in other atomic classes. Because this class cannot ensure that all uses of the field are appropriate for purposes of atomic access, it can guarantee atomicity and volatile semantics only with respect to other invocations of `compareAndSet` and `set`.

Since:
  1.5

Constructor Summary
`protected` | `AtomicReferenceFieldUpdater()` Protected do-nothing constructor for use by subclasses.

Method Summary
`abstract boolean` | `compareAndSet(T obj, V expect, V update)` Atomically set the value of the field of the given object managed by this Updater to the given updated value if the current value `==` the expected value.
`abstract V` | `get(T obj)` Get the current value held in the field by the given object.
`V` | `getAndSet(T obj, V newValue)` Set to the given value and return the old value.
`static
`<U,W> AtomicReferenceFieldUpdater<U,W>`
` | `newUpdater(Class<U> tclass, Class<W> vclass, String fieldName)` Creates an updater for objects with the given field.
`abstract void` | `set(T obj, V newValue)` Set the field of the given object managed by this updater.
`abstract boolean` | `weakCompareAndSet(T obj, V expect, V update)` Atomically set the value of the field of the given object managed by this Updater to the given updated value if the current value `==` the expected value.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### AtomicReferenceFieldUpdater

    protected AtomicReferenceFieldUpdater()

  Protected do-nothing constructor for use by subclasses.

Method Detail

### newUpdater

    public static <U,W> AtomicReferenceFieldUpdater<U,W> newUpdater(Class<U> tclass,
                                                                    Class<W> vclass,
                                                                    String fieldName)

  Creates an updater for objects with the given field. The Class arguments are needed to check that reflective types and generic types match.

  Parameters:
    `tclass` - the class of the objects holding the field.
    `vclass` - the class of the field
    `fieldName` - the name of the field to be updated.
  Returns:
    the updater
  Throws:
    `IllegalArgumentException` - if the field is not a volatile reference type.
    `RuntimeException` - with a nested reflection-based exception if the class does not hold field or is the wrong type.

### compareAndSet

    public abstract boolean compareAndSet(T obj,
                                          V expect,
                                          V update)

  Atomically set the value of the field of the given object managed by this Updater to the given updated value if the current value `==` the expected value. This method is guaranteed to be atomic with respect to other calls to `compareAndSet` and `set`, but not necessarily with respect to other changes in the field.

  Parameters:
    `obj` - An object whose field to conditionally set
    `expect` - the expected value
    `update` - the new value
  Returns:
    true if successful.

### weakCompareAndSet

    public abstract boolean weakCompareAndSet(T obj,
                                              V expect,
                                              V update)

  Atomically set the value of the field of the given object managed by this Updater to the given updated value if the current value `==` the expected value. This method is guaranteed to be atomic with respect to other calls to `compareAndSet` and `set`, but not necessarily with respect to other changes in the field, and may fail spuriously.

  Parameters:
    `obj` - An object whose field to conditionally set
    `expect` - the expected value
    `update` - the new value
  Returns:
    true if successful.

### set

    public abstract void set(T obj,
                             V newValue)

  Set the field of the given object managed by this updater. This operation is guaranteed to act as a volatile store with respect to subsequent invocations of `compareAndSet`.

  Parameters:
    `obj` - An object whose field to set
    `newValue` - the new value

### get

    public abstract V get(T obj)

  Get the current value held in the field by the given object.

  Parameters:
    `obj` - An object whose field to get
  Returns:
    the current value

### getAndSet

    public V getAndSet(T obj,
                       V newValue)

  Set to the given value and return the old value.

  Parameters:
    `obj` - An object whose field to get and set
    `newValue` - the new value
  Returns:
    the previous value

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Standard Ed. 5.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Copyright 2004 Sun Microsystems, Inc. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.